unit MyService;

interface

uses
  SysUtils,
  XData.Server.Module,
  XData.Service.Common;

type
  [ServiceContract]
  IMyService = interface(IInvokable)
    ['{A937749F-0F94-43B4-BDCB-9C5216DFF7A5}']
    [HttpGet] function Sum(A, B: double): double;
    // By default, any service operation responds to (is invoked by) a POST request from the client.
    [HttpGet] function EchoString(Value: string): string;
  end;

  [ServiceImplementation]
  TMyService = class(TInterfacedObject, IMyService)
  private
    function Sum(A, B: double): double;
    function EchoString(Value: string): string;
  end;

implementation

function TMyService.Sum(A, B: double): double;
begin
  Result := A + B;
end;

function TMyService.EchoString(Value: string): string;
begin
  Result := Value;
  Sleep(50000);
end;

initialization
  RegisterServiceType(TypeInfo(IMyService));
  RegisterServiceType(TMyService);

end.
